<link rel="import" href="../polymer/polymer-element.html" />

<dom-module id="my-repeat">
    <template>
        <style></style>
        <h1>For para elementos en arreglos</h1>
        <template is="dom-repeat" items="{{items}}" filter="isOlderThan40" sort="mySort" as="item">
            <h2>Elemento</h2>
            <div>[[item.name]] - [[item.age]]</div>
            <template is="dom-if" if="{{isMyPartner(item.name)}}">
                <p>Hola [[item.name]]!</p>
            </template>
            <template is="dom-if" if="{{!isMyPartner(item.name)}}">
                <p>No te conozco [[item.name]]!</p>
            </template>
        </template>
    </template>

    <script>
        /**
         * `my-repeat`
         * dcfvgbhj
         *
         * @customElement
         * @polymer
         * @demo demo/index.html
         */
        class MyRepeat extends Polymer.Element {
            static get is() {
                return "my-repeat";
            }
            static get properties() {
                return {
                    items: {
                        type: Array,
                        value: [
                            { name: "Emil", age: 28 },
                            { name: "Jonas", age: 58 },
                            { name: "Erik", age: 48 },
                            { name: "Danielle", age: 38 },
                        ],
                    },
                };
            }

            isOlderThan40(item) {
                return item.age > 40;
            }

            mySort(a, b) {
                const nameA = a.name.toUpperCase();
                const nameB = b.name.toUpperCase();
                if (nameA > nameB) {
                    return -1;
                } else if (nameA < nameB) {
                    return 1;
                }

                return 0;
            }

            isMyPartner(item) {
                return item === "Jonas";
            }
        }

        window.customElements.define(MyRepeat.is, MyRepeat);
    </script>
</dom-module>
